<?php 

/**
 * @file
 * Provide views data and handlers for gallerix.module
 */



/**
 * Implementation of hook_views_data()
 */
function gallerix_views_data() {

  $data['gallerix_albums']['table']['group'] = t('Gallerix'); 
  $data['gallerix_albums']['table']['join'] = array(
    'node' => array(
      'left_field' => 'nid',
      'field' => 'nid',
      'type' => 'INNER',
    ),
  );
    
  $data['gallerix_albums']['path'] = array(
    'title' => t('Album Thumbnail'),
    'help' => t('The first picture in the album. A placeholder will be shown if the album is empty.'),
    'field' => array(
      'handler' => 'views_handler_field_album',
    ),
  
  );
  
  /*

  // Shared Fields
  $data['joinky_shared_fields']['table']['group']  = t('Joinky');  
  $data['joinky_shared_fields']['table']['join'] = array(
    'node' => array(
      'left_field' => 'nid',
      'field' => 'nid',
      'type' => 'INNER',
    ),
  );
  
  
  $data['joinky_shared_fields']['max_users'] = array(
    'title' => t('Max Users'),
    'help' => t('Max number of users.'),

    'field' => array(
      'handler' => 'views_handler_field_instance',
      'click sortable' => TRUE,
    ),
 
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    
    'sort' => array(
      'handler' => 'views_handler_sort_current_users',
    ),
  );
  $data['joinky_shared_fields']['min_users'] = array(
    'title' => t('Min Users'),
    'help' => t('Min number of users.'),

    'field' => array(
      'handler' => 'views_handler_field_instance',
      'click sortable' => TRUE,
    ),

    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );
  
  
  // Instance Fields
  $data['joinky_instance_fields']['table']['group']  = t('Joinky');  
  $data['joinky_instance_fields']['table']['join'] = array(
    'node' => array(
      'left_field' => 'nid',
      'field' => 'nid',
      'type' => 'INNER',      
    ),
  );
  
  $data['joinky_instance_fields']['pid'] = array(
    'title' => t('Parent Project'),
    'help' => t('Project the instance belongs to.'), 

    'field' => array(
      'handler' => 'views_handler_field_instance',
      'click sortable' => TRUE,
    ),
    
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),    
  );  
  
  $data['joinky_instance_fields']['difficulty'] = array(
    'title' => t('Difficulty'),
    'help' => t('The difficulty of the instance.'), 

    'field' => array(
      'handler' => 'views_handler_field_instance',
      'click sortable' => TRUE,
    ),
    
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),    
  );
  $data['joinky_instance_fields']['current_users'] = array(
    'title' => t('Current Users'),
    'help' => t('The number of users in the instance.'), 

    'field' => array(
      'handler' => 'views_handler_field_instance',
      'click sortable' => TRUE,
    ),
    
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),    
  );      
*/
  return $data;


}








/**
 * Implementation of hook_views_handlers() to register all of the basic handlers
 * gallerix uses.
 */
function gallerix_views_handlers() {
  return array(
    'info' => array(
    ),
    'handlers' => array(
      // field handlers
      'views_handler_field_album' => array(
        'parent' => 'views_handler_field',
      ),
    ),
  );
}



/*




function gallerix_views_default_views() {

  $view = new stdClass();
  $view->name = 'gallerix_grid';
  $view->description = 'Grid view of all albums.';
  $view->access = array (
  );

  $view->view_args_php = '';
  $view->page = TRUE;
  $view->page_title = 'All Albums';
  $view->page_header = '';
  $view->page_header_format = '1';
  $view->page_footer = '';
  $view->page_footer_format = '1';
  $view->page_empty = '';
  $view->page_empty_format = '1';
  $view->page_type = 'list';
  $view->url = 'gallery';
  $view->use_pager = TRUE;
  $view->nodes_per_page = '24';
  $view->sort = array (
    array (
      'tablename' => 'node',
      'field' => 'created',
      'sortorder' => 'DESC',
      'options' => 'normal',
    ),
  );
  $view->argument = array (
    array (
      'type' => 'uid',
      'argdefault' => '2',
      'title' => 'Albums by %1',
      'options' => '',
      'wildcard' => '',
      'wildcard_substitution' => '',
    ),
  );
  $view->field = array (
    array (
      'tablename' => 'gallerix',
      'field' => 'gallerix',
      'label' => '',
      'handler' => 'gallerix_views_handler_album',
      'options' => 'thumbnail',
    ),
  );
  $view->filter = array (
    array (
      'tablename' => 'node',
      'field' => 'type',
      'operator' => 'OR',
      'options' => '',
      'value' => array (
        0 => 'album',
      ),
    ),
  );
  $view->exposed_filter = array (
  );
  $view->requires = array(node, gallerix);
  $views[$view->name] = $view;
  
  return $views;

}





function gallerix_views_tables() {
  $tables['gallerix'] = array(
    'name' => 'gallerix',
    'fields' => array(
      'gallerix' => array(
        'name' => t('Gallerix: Album Thumbnail'),
        'handler' => array(
          'gallerix_views_handler_album' => t('Image'),
        ),
        'option' => array(
          '#type' => 'select',
          '#options' => 'gallerix_views_sizes',
        ),
        'notafield' => true,
        'sortable' => false,
      ),
    ),
  );
  return $tables;
}






function gallerix_views_sizes() {
  $sizes = gallerix_sizes();
  $content = array();
  
  foreach ($sizes as $key => $size) {
    $content[$key] = $size['label'];
  }
  
  return $content;
}


*/

/**
 * Views handler for displaying the image.
 */ /*
function gallerix_views_handler_album($fieldinfo, $fielddata, $value, $data) {
  $node = node_load($data->nid);
  
  gallerix_load_style();
  
  return theme('gallerix_albums_grid', $node, $fielddata['options']);
}

*/



/**
 * Theme the grid containing all albums.
 *
 */
function theme_views_view_gallerix_grid($view, $type, $nodes, $level = NULL, $args = NULL) {
  $output = '';
  $output .= '<div class="gallerix-grid-view">';
  
  gallerix_load_style();
  gallerix_load_js();

  foreach($nodes as $node) {
    $output .= theme('gallerix_albums_grid', $node);
  }
  
  $output .= '</div>';
  
  return $output;
}




/**
 * Themes each thumbnail to be displayed by the default view.
 *
 */
function theme_gallerix_albums_grid($node, $size = 'thumbnail') {
  $node = node_load($node->nid);
  $translucent = variable_get('gallerix_translucence', 1) ? ' translucent' : '';
  
  if ($node->gallerix['default']) {
    $default = gallerix_load_picture($node->gallerix['default']);
    $thumbnail = theme('image', $default->$size, '', $node->title, array('class' => 'gallerix-external-thumbnail' . $translucent));
  
  }

  $link =  l($thumbnail, 'node/' . $node->nid, array('attributes' => array('class' => 'gallerix-external-picture-link'), 'html' => TRUE));
  
  $output .= $link;

  return $output;
}

